<?php
/**
 * @Module Name: 1Pay Payments | Joomla
 * Plugin URI: http://1pay.in
 * Description: Extends Joomla with 1Pay services
 * Version: 1.0.3
 * @author: Soumil Gada, Manisha Gupta
 * Author EMAIL: soumil.gada@mobilewaretech.com
 * @copyright: @2018 Mobilewaretech. All rights reserved
 */
defined('_JEXEC') or die('Restricted access');

/**
 */
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVmPaymentOnePay extends vmPSPlugin
{

    // instance of class
    public static $_this = false;
    private $ekey = '3a5c1c4e81d7eb133a5c1c4e81d7eb13';
    function __construct(& $subject, $config)
    {

        parent::__construct($subject, $config);

        $this->_loggable = true;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $this->_tablepkey = 'id';
        $this->_tableId = 'id';
        $varsToPush = array(
            'apiKey' => array('', 'int'),
            'merchantid' => array('', 'char'),
            'mode' => array('', 'char'),
            'description' => array('', 'text'),
            'payment_logos' => array('', 'char'),
            'payment_currency' => array('', 'int'),
            'status_pending' => array('', 'char'),
            'status_success' => array('', 'char'),
            'status_canceled' => array('', 'char'),
            'countries' => array('', 'char'),
            'min_amount' => array('', 'int'),
            'max_amount' => array('', 'int'),
            'secure_post' => array('', 'int'),
            'ipn_test' => array('', 'int'),
            'no_shipping' => array('', 'int'),
            'address_override' => array('', 'int'),
            'cost_per_transaction' => array('', 'int'),
            'cost_percent_total' => array('', 'int'),
            'tax_id' => array(0, 'int')
        );

        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

    }

    public function getVmPluginCreateTableSQL()
    {
        return $this->createTableSQL('Payment OnePay Table');
    }

    function getTableSQLFields()
    {
        $SQLfields = array(
            'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
            'virtuemart_order_id' => 'int(1) UNSIGNED',
            'order_number' => ' char(64)',
            'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
            'payment_name' => 'varchar(5000)',
            'OnePay_custom' => ' varchar(255)',
            'amount' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
            'status' => 'varchar(225)',
            'mode' => 'varchar(225)',
            'mihpayid' => 'int(11)',
            'productinfo' => 'text',
            'mihpayid' => 'int(21)',
            'txnid' => 'varchar(29)',
        );
        return $SQLfields;
    }


    function get_string_between($string, $start, $end)
    {
        $string = ' ' . $string;
        $ini = strpos($string, $start);
        if ($ini == 0) return '';
        $ini += strlen($start);
        $len = strpos($string, $end, $ini) - $ini;
        return substr($string, $ini, $len);
    }

    function request($url, $postData)
    {
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        $data = curl_exec($ch);
        curl_close($ch);
        return json_decode($data);
    }

    function checksum($data)
    {
        $url = $data['url'] . 'checksumgenerator';
        $myvars = "merchantId=" . $data['merchantId'] . "&txnId=" . $data['txnId'] . "&dateTime=" . $data['dateTime'] . "&amount=" . $data['amount'] . "&apiKey=" . $data['apiKey'] . "&custMobile=" . $data['custMobile'] . "&custMail=" . $data['custMail'] . "&channelId=0&txnType=DIRECT";

        $checksum = $this->request($url, $myvars);
        return $checksum->checksum;
    }

    function verify($data)
    {
        $url = $data['url'] . 'verifyTxn';
        $myvars = "respData=" . $data['respData'];


        //updated method added
         $myvars = "merchantId=" . $data['merchantId'] . "&txnId=" . $data['txnId'] . "";
        //$myvars = "respData=" . $data['respData'];


        $resdata = $this->request($url, $myvars);

        return $resdata;
    }

    function plgVmConfirmedOrder($cart, $order)
    {
        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $session = JFactory::getSession();
        $return_context = $session->getId();
        $this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');

        if (!class_exists('VirtueMartModelOrders'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        if (!class_exists('VirtueMartModelCurrency'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');


        //$usr = JFactory::getUser();
        $new_status = '';
        $usrBT = $order['details']['BT'];
        $address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);

        if (!class_exists('TableVendors'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
        $vendorModel = VmModel::getModel('Vendor');
        $vendorModel->setId(1);
        $vendor = $vendorModel->getVendor();
        $vendorModel->addImages($vendor, 1);
        /*$this->getPaymentCurrency($method);
        $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
        $db = JFactory::getDBO();
        $db->setQuery($q);
        $currency_code_3 = $db->loadResult();

        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
        $cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
        if ($totalInPaymentCurrency <= 0) {
             vmInfo(JText::_('VMPAYMENT_OnePay_PAYMENT_AMOUNT_INCORRECT'));
                return false;
        }*/
        $apiKey = $this->_getMerchantApiKey($method);
        if (empty($apiKey)) {
            vmInfo(JText::_('VMPAYMENT_OnePay_MERCHANT_APIKEY_NOT_SET'));
            return false;
        }
        $udf5 = "Virtuemart_v_3.4";
        $merchentid = $method->merchantid;
        $mode = $method->mode;
        $return_url = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&DR={DR}');
        $description = $method->description;
        $ship_address = $address->address_1;
        $txnid = $order['details']['BT']->order_number;


        if (isset($address->address_2)) {
            $ship_address .= ", " . $address->address_2;
        }
        $url = $this->_getOnePayUrlHttps($method);

        $post_variables = Array(
            "merchantId" => $merchentid,
            "apiKey" => $apiKey,
            "txnId" => $txnid,
            "url" => $url,
            "channelId" => '0',
            "txnType" => 'DIRECT',
            "instrumentId" => 'NA',
            "bankId" => 'NA',
            "productId" => 'DEFAULT',
            "dateTime" => date('Y-m-d h:i:s'),
            "amount" => number_format((double)$order['details']['BT']->order_total,2,'.',''),
            "lastname" => $order['details']['BT']->last_name,
            "address" => $order['details']['BT']->address_1 . " " . $order['details']['BT']->address_2,
            "custMobile" => $order['details']['BT']->phone_1,
            "custMail" => $order['details']['BT']->email,
            "service_provider" => "OnePay_PG",
            "isMultiSettlement" => '0',
            "udf1" => "NA",
            "udf2" => "NA",
            "udf3" => "NA",
            "cardType" => "NA",
            "returnURL" => $return_url,
            'cardDetails' => 'NA',
            'udf4' => 'NA',
            'udf5' => 'NA',
        );

        $checksum = $this->checksum($post_variables);
//x
        $post_variables['checksum'] = $checksum;

        $dbValues['order_number'] = $order['details']['BT']->order_number;
        $dbValues['payment_name'] = $this->renderPluginName($method, $order);
        $dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
        $dbValues['description'] = '$description';//$description;
        $dbValues['OnePay_custom'] = $return_context;
        $dbValues['billing_currency'] = $method->payment_currency;
        $dbValues['amount'] = (int)(int)$order['details']['BT']->order_total;
        $this->storePSPluginInternalData($dbValues);


// added updated method

        $jsondata = json_encode($post_variables);
        $enc = $this->get_encrypt($jsondata);

        $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
        $html .= '<form action="' . $url . 'payprocessor" method="post" name="vm_OnePay_form" >';
        $html .= '<input type="submit"  value="' . JText::_('VMPAYMENT_OnePay_REDIRECT_MESSAGE') . '" />';
        $html .= '<input type="hidden" style="" name="merchantId" value="' .$post_variables['merchantId']. '" />';
        $html .= '<input type="hidden" style="" name="reqData" value="' .$enc. '" />';
        
        $html .= '</form></div>';
        $html .= ' <script type="text/javascript">';
        $html .= ' document.vm_OnePay_form.submit();';
        $html .= ' </script></body></html>';

        // 	2 = don't delete the cart, don't send email and don't redirect
        $cart->_confirmDone = false;
        $cart->_dataValidated = false;
        $cart->setCartIntoSession();
        JRequest::setVar('html', $html);
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $this->getPaymentCurrency($method);
        $paymentCurrencyId = $method->payment_currency;
    }

    function plgVmOnPaymentResponseReceived(&$html)
    {
        if (!class_exists('VirtueMartCart'))
            require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
        if (!class_exists('shopFunctionsF'))
            require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
        if (!class_exists('VirtueMartModelOrders'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        // the payment itself should send the parameter needed.
        $virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
        $order_number = JRequest::getString('on', 0);

        $vendorId = 0;
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return null;
        }
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
            return null;
        }
        if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
            // JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        $payment_name = 'One Pay';//$this->renderPluginName($method);
        $response = array();
        $response = $_POST;
        $respData = $response['respData'];
        //updated method added
        
        $respDecrypt = $this->get_decrypt($respData);
        $verificationResult = json_decode($respDecrypt);
        
        $url = $this->_getOnePayUrlHttps($method);
        
        $verify = $this->verify(array('url' => $url,'merchantId' =>$verificationResult->merchant_id,'txnId' => $verificationResult->txn_id));
       
        $parsedtxnid = $verify->txn_id;
        $parsedmerchantid = $verify->merchant_id;
        $parsedtxnamount = $verify->txn_amount;
        $parsedtxnstatus = $verify->trans_status;
        $responseMessage = $verify->resp_message;
        $orderid = $parsedtxnid;
    

        if (($responseMessage === 'No Error.') && ($parsedtxnstatus !== 'NA')) {
            $vmessage = "Verified Transaction";
            
            if ($parsedtxnstatus == 'Ok') {
                
                $status_msg = "Transaction Successful";
                $new_status = $method->status_success;

                $modelOrder = VmModel::getModel('orders');
                $order['order_status'] = $new_status;

                $order['customer_notified'] = 1;
                $order['comments'] = $status_msg;
                $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
                $response = array(
                    'txn_id' => $orderid,
                    'amount' => $parsedtxnamount,
                    'txn_status' => $parsedtxnstatus,
                    'txn_id' => $orderid,
                    'mode' => $verify->payment_mode,
                    'mihpayid'=>$verify->bank_ref_id,
                    'productinfo'=>$respData
                );

                $this->_storeOnePayInternalData($method, $response, $virtuemart_order_id, $paymentTable->OnePay_custom);
                $html = $this->_getPaymentResponseHtml($paymentTable, $payment_name, $response);
            } else if ($txnstatus == 'To') {
                $status_msg = "Sorry!!Your Transaction is Timed Out";
                $new_status = $method->status_canceled;
                $modelOrder = VmModel::getModel('orders');
                $order['order_status'] = $new_status;

                $order['customer_notified'] = 1;
                $order['comments'] = $status_msg;
                $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);

                $this->_storeOnePayInternalData($method, $response, $virtuemart_order_id, $paymentTable->OnePay_custom);
                $cancel_return = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order_number . '&pm=' . $virtuemart_paymentmethod_id);
                $html = ' <script type="text/javascript">';
                $html .= 'window.location = "' . $cancel_return . '"';
                $html .= ' </script>';

            } else {
                $status_msg = "Transaction Failed";
                $new_status = $method->status_canceled;
                $modelOrder = VmModel::getModel('orders');
                $order['order_status'] = $new_status;

                $order['customer_notified'] = 1;
                $order['comments'] = $status_msg;
                $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);

                $this->_storeOnePayInternalData($method, $response, $virtuemart_order_id, $paymentTable->OnePay_custom);
                $cancel_return = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order_number . '&pm=' . $virtuemart_paymentmethod_id);
                $html = ' <script type="text/javascript">';
                $html .= 'window.location = "' . $cancel_return . '"';
                $html .= ' </script>';
            }
            JRequest::setVar('html', $html);
        } else {

            $vmessage = "Transaction Failed";

            $new_status = $method->status_canceled;
            $modelOrder = VmModel::getModel('orders');
            $order['order_status'] = $new_status;
            $order['customer_notified'] = 1;
            $order['comments'] = $responseMessage;
            $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
            $cancel_return = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order_number . '&pm=' . $virtuemart_paymentmethod_id);
            $html = ' <script type="text/javascript">';
            $html .= 'window.location = "' . $cancel_return . '"';
            $html .= ' </script>';
            JRequest::setVar('html', $html);
        }
        // get the correct cart / session
        $cart = VirtueMartCart::getCart();
        $cart->emptyCart();
        return true;
    }

    function _getPaymentResponseHtml($paymentTable, $payment_name, $response)
    {
        $html = '<table>' . "\n";
        $html .= $this->getHtmlRow('OnePay_PAYMENT_NAME', $payment_name);
        if (!empty($paymentTable)) {
            //$html .= $this->getHtmlRow('OnePay_ORDER_NUMBER', $paymentTable->order_number);
            $html .= $this->getHtmlRow('OnePay_VIRTUEMART_ORDER_ID', $paymentTable->virtuemart_order_id);
        }


        $tot_amount = $response['amount'] . " INR";
        $html .= $this->getHtmlRow('OnePay_AMOUNT', $tot_amount);


        return $html;
    }

    function _storeOnePayInternalData($method, $response, $virtuemart_order_id, $custom)
    {
        
        $virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
        $response_fields['payment_name'] = $this->renderPluginName($method);
        $response_fields['virtuemart_order_id'] = $virtuemart_order_id;
        $response_fields['virtuemart_paymentmethod_id'] = $virtuemart_paymentmethod_id;
        $response_fields['order_number'] = $response['txn_id'];
        $response_fields['OnePay_custom'] = $custom;
        $response_fields['amount'] = $response['amount'];
        $response_fields['status'] = $response['txn_status'];
        $response_fields['mode'] = ucfirst($response['mode']);
        $response_fields['mihpayid'] = $response['mihpayid'];
        $response_fields['productinfo'] = $response['productinfo'];
        $response_fields['txnid'] = $response['txn_id'];
        $this->storePSPluginInternalData($response_fields, 'virtuemart_order_id', true);
    }

    function plgVmOnUserPaymentCancel()
    {
        if (!class_exists('VirtueMartModelOrders'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');

        $order_number = JRequest::getString('on', '');
        $virtuemart_paymentmethod_id = JRequest::getInt('pm', '');
        if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id)) {
            return null;
        }
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
            return null;
        }
        if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
            return null;
        }

        VmInfo(Jtext::_('VMPAYMENT_OnePay_PAYMENT_CANCELLED'));
        $session = JFactory::getSession();
        $return_context = $session->getId();
        if (strcmp($paymentTable->OnePay_custom, $return_context) === 0) {
            $this->handlePaymentUserCancel($virtuemart_order_id);
        }
        return true;
    }


    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id)
    {
        if (!$this->selectedThisByMethodId($payment_method_id)) {
            return null; // Another method was selected, do nothing
        }
        if (!($paymentTable = $this->_getOnePayInternalData($virtuemart_order_id))) {
            // JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentTable->billing_currency . '" ';
        $db = JFactory::getDBO();
        $db->setQuery($q);
        $currency_code_3 = $db->loadResult();
        $html = '<table class="adminlist">' . "\n";
        $html .= $this->getHtmlHeaderBE();
        $html .= $this->getHtmlRowBE('OnePay_PAYMENT_NAME', $paymentTable->payment_name);
        //echo "<pre>";print_r($paymentTable);echo "</pre>";
        $html .= $this->getHtmlRowBE('OnePay_VIRTUEMART_ORDER_ID', $paymentTable->virtuemart_order_id);
        $html .= $this->getHtmlRowBE('OnePay_RESPONSE_MESSAGE', $paymentTable->status);
        $html .= $this->getHtmlRowBE('OnePay_PAYMENT_ID', $paymentTable->mihpayid);
        $html .= $this->getHtmlRowBE('OnePay_AMOUNT', $paymentTable->amount . ' INR');
        $html .= $this->getHtmlRowBE('OnePay_MODE', $paymentTable->mode);
        $html .= $this->getHtmlRowBE('OnePay_PAYMENT_TRANSACTION_ID', $paymentTable->txnid);
        $html .= $this->getHtmlRowBE('OnePay_PAYMENT_DATE', $paymentTable->modified_on);
        $html .= '</table>' . "\n";
        return $html;
    }

    function _getOnePayInternalData($virtuemart_order_id, $order_number = '')
    {
        $db = JFactory::getDBO();
        $q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
        if ($order_number) {
            $q .= " `order_number` = '" . $order_number . "'";
        } else {
            $q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
        }
        $db->setQuery($q);
        if (!($paymentTable = $db->loadObject())) {
            // JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        return $paymentTable;
    }


    function _getMerchantApiKey($method)
    {
        return $method->apiKey;
    }

    function _getOnePayUrlHttps($method)
    {
        $url = 'http://139.59.1.254:8080/payone/';
        if ($method->mode == 'LIVE')
            $url = 'https://pay.1paypg.in/payone/';
        return $url;
    }


    function getCosts(VirtueMartCart $cart, $method, $cart_prices)
    {
        if (preg_match('/%$/', $method->cost_percent_total)) {
            $cost_percent_total = substr($method->cost_percent_total, 0, -1);
        } else {
            $cost_percent_total = $method->cost_percent_total;
        }
        return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }

    protected function checkConditions($cart, $method, $cart_prices)
    {
        $this->convert($method);
        $address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
        $amount = $cart_prices['salesPrice'];
        $amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
            OR
            ($method->min_amount <= $amount AND ($method->max_amount == 0)));
        $countries = array();
        if (!empty($method->countries)) {
            if (!is_array($method->countries)) {
                $countries[0] = $method->countries;
            } else {
                $countries = $method->countries;
            }
        }
        // probably did not gave his BT:ST address
        if (!is_array($address)) {
            $address = array();
            $address['virtuemart_country_id'] = 0;
        }
        if (!isset($address['virtuemart_country_id']))
            $address['virtuemart_country_id'] = 0;
        if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
            if ($amount_cond) {
                return true;
            }
        }
        return false;
    }

    function convert($method)
    {
        $method->min_amount = (float)$method->min_amount;
        $method->max_amount = (float)$method->max_amount;
    }

    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
    {
        return $this->OnSelectCheck($cart);
    }

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn)
    {
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter)
    {
        return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data)
    {
        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
        return $this->setOnTablePluginParams($name, $id, $table);
    }


    function plgVmDeclarePluginParamsPaymentVM3(&$data)
    {
        return $this->declarePluginParams('payment', $data);
    }
    
    public function get_encrypt($input) {
            //for php 5.x.x to 7.0.x
            $key = $this->ekey;
            $size = mcrypt_get_block_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_ECB);

            $input = $this->get_pkcs5_pad($input, $size);

            $td = mcrypt_module_open(MCRYPT_RIJNDAEL_128, '', MCRYPT_MODE_ECB, '');

            $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_RAND);

            mcrypt_generic_init($td, $key, $iv);
            $data = mcrypt_generic($td, $input);

            mcrypt_generic_deinit($td);
            mcrypt_module_close($td);
            $data = base64_encode($data);

            //die;
            return $data;
        }

        protected function get_pkcs5_pad($text, $blocksize) {
            $pad = $blocksize - (strlen($text) % $blocksize);
            return $text . str_repeat(chr($pad), $pad);
        }

        public function get_decrypt($input) {
            $key = $this->ekey;
            $decrypted = mcrypt_decrypt(
                    MCRYPT_RIJNDAEL_128, $key, base64_decode($input), MCRYPT_MODE_ECB
            );
            $dec_s = strlen($decrypted);
            $padding = ord($decrypted[$dec_s - 1]);
            $decrypted = substr($decrypted, 0, -$padding);


            return $decrypted;
        }

}
